/**
 * adpushup/IframeClickTracker is licensed under the MIT License
 *
 * MIT License
 *
 *
 * Copyright (c) 2017 AdPushup Inc.
 *
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * jfriend00/docReady is licensed under the MIT License
 *
 * The MIT License (MIT)
 *
 *
 * Copyright (c) 2014, John Friend
 *
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE. 
 */

(function(modules){var installedModules={};function __webpack_require__(moduleId){if(installedModules[moduleId]){return installedModules[moduleId].exports}var module=installedModules[moduleId]={i:moduleId,l:false,exports:{}};modules[moduleId].call(module.exports,module,module.exports,__webpack_require__);module.l=true;return module.exports}__webpack_require__.m=modules;__webpack_require__.c=installedModules;__webpack_require__.d=function(exports,name,getter){if(!__webpack_require__.o(exports,name)){Object.defineProperty(exports,name,{configurable:false,enumerable:true,get:getter})}};__webpack_require__.n=function(module){var getter=module&&module.__esModule?function getDefault(){return module["default"]}:function getModuleExports(){return module};__webpack_require__.d(getter,"a",getter);return getter};__webpack_require__.o=function(object,property){return Object.prototype.hasOwnProperty.call(object,property)};__webpack_require__.p="";return __webpack_require__(__webpack_require__.s=3)})([function(module,exports,__webpack_require__){var docReady=__webpack_require__(1);module.exports=function(){var browserConfig={name:"other",pingEl:null,pageVisibility:{supported:false,type:null,vendorPrefix:null},animation:{supported:false,keyframeprefix:"",pfx:"",animationstring:"animationName"},dataSendingMethod:null,unloadMethod:null,trackerSupported:false};(function detectBrowser(){var ua=navigator.userAgent;try{if((!!window.opera||ua.indexOf(" OPR/")>=0)&&ua.indexOf("Opera Mini")==-1){browserConfig.name="opera"}else if(ua.indexOf("Edge")!==-1){browserConfig.name="edge"}else if(typeof InstallTrigger!=="undefined"){browserConfig.name="firefox"}else if(/Android/i.test(ua)&&typeof navigator.vendor!=="undefined"&&navigator.vendor.indexOf("Google")>-1&&/ Version\/[^ ]+ Chrome/i.test(ua)){browserConfig.name="chrome-wv"}else if(!!window.chrome&&ua.match(/chrome/i)){browserConfig.name="chrome"}else if(false||!!document.documentMode){browserConfig.name="ie"}else if(navigator.vendor&&navigator.vendor.indexOf("Apple")>-1){browserConfig.name="safari"}}catch(e){}})();(function detectVisibilitySupport(){browserConfig.pageVisibility.supported=true;browserConfig.pageVisibility.type="standard";if(document.visibilityState!==void 0)browserConfig.pageVisibility.vendorPrefix="";else if(document.webkitVisibilityState!==void 0)browserConfig.pageVisibility.vendorPrefix="webkit";else if(document.mozVisibilityState!==void 0)browserConfig.pageVisibility.vendorPrefix="moz";else if(document.msVisibilityState!==void 0)browserConfig.pageVisibility.vendorPrefix="ms";else if(document.hasFocus!==void 0)browserConfig.pageVisibility.type="blur";else{browserConfig.pageVisibility.type=null;browserConfig.pageVisibility.supported=false}})();(function detectDataSendingMethod(){if(navigator&&typeof navigator.sendBeacon==="function"){browserConfig.dataSendingMethod="sendBeacon"}else if((browserConfig.name.match(/^safari*/)||browserConfig.name.match(/chrome*/)||browserConfig.name=="opera")&&typeof document.createElement("a").ping!="undefined"){browserConfig.dataSendingMethod="ping"}})();(function initBeacon(){if(browserConfig.dataSendingMethod==="ping"){docReady(function(e){var a=document.createElement("a");a.href="javascript:void(0)";a.style.display="none";a.id="_ap_ping_tracker";a.ping="";document.body.appendChild(a);browserConfig.pingEl=a;browserConfig.pingEl.click(function(e){e.stopPropagation();e.stopImmediatePropagation()})})}})();(function detectUnloadMethod(){browserConfig.unloadMethod=browserConfig.name.match("safari*")?"pagehide":"beforeunload"})();(function detectAnimationSupport(){var elm=document.createElement("div"),domPrefixes="Webkit Moz O ms Khtml".split(" ");if(elm.style.animationName!==undefined){browserConfig.animation.supported=true}if(browserConfig.animation.supported===false){for(i=0;i<domPrefixes.length;i++){if(elm.style[domPrefixes[i]+"AnimationName"]!==undefined){browserConfig.animation.pfx=domPrefixes[i];browserConfig.animation.animationstring=browserConfig.animation.pfx+"AnimationName";browserConfig.animation.keyframeprefix="-"+browserConfig.animation.pfx.toLowerCase()+"-";browserConfig.animation.supported=true;break}}}})();(function checkTrackerSupport(){browserConfig.trackerSupported=!(browserConfig.name==="other"||!browserConfig.pageVisibility.supported||browserConfig.name=="safari"&&typeof window.requestAnimationFrame!="function")})();browserConfig.pageVisibility.isPageVisible=function(){var pV=browserConfig.pageVisibility;if(!pV.supported)return-1;else if(pV.type==="standard")return document[pV.vendorPrefix+"visibilityState"]==="visible";else return document.hasFocus()};browserConfig.pageVisibility.getVisiblityState=function(){var pV=browserConfig.pageVisibility;if(!pV.supported)return false;else if(pV.type==="standard")if(!pV.vendorPrefix)return document.visibilityState;else return document[pV.vendorPrefix+"VisibilityState"];else return document.hasFocus()?"visible":"hidden"};browserConfig.pageVisibility.onChange=function(hiddenCallback,visibleCallback){var pV=browserConfig.pageVisibility;window.currentState=browserConfig.pageVisibility.getVisiblityState();var hidden="hidden";if(pV.type==="standard")document.addEventListener(pV.vendorPrefix+"visibilitychange",onchange);else if(pV.type==="blur")document.onfocusin=document.onfocusout=onchange;else window.onpageshow=window.onpagehide=window.onfocus=window.onblur=onchange;function onchange(evt){var evtMap={focus:"visible",pageshow:"visible",blur:"hidden",pagehide:"hidden"};evt=evt||window.event;var evtType=evt.type;var triggerCallback=function(visibleState,event){if(window.currentState!==visibleState){window.currentState=visibleState;if(visibleState==="hidden")hiddenCallback();else visibleCallback()}};if(this[pV.vendorPrefix+"hidden"])triggerCallback("hidden",evt.type);else triggerCallback("visible",evt.type);if(evtMap[evtType]==="visible"){triggerCallback("visible",evt.type)}else{setTimeout(function(){if(!document.hasFocus())triggerCallback("hidden",evtType)},1e3)}}};return browserConfig}()},function(module,exports){module.exports=function(funcName,baseObj){funcName=funcName||"docReady";baseObj=baseObj||window;var readyList=[];var readyFired=false;var readyEventHandlersInstalled=false;function ready(){if(!readyFired){readyFired=true;for(var i=0;i<readyList.length;i++){readyList[i].fn.call(window,readyList[i].ctx)}readyList=[]}}function readyStateChange(){if(document.readyState==="complete"){ready()}}baseObj[funcName]=function(callback,context){if(typeof callback!=="function"){throw new TypeError("callback for docReady(fn) must be a function")}if(readyFired){setTimeout(function(){callback(context)},1);return}else{readyList.push({fn:callback,ctx:context})}if(document.readyState==="complete"||!document.attachEvent&&document.readyState==="interactive"){setTimeout(ready,1)}else if(!readyEventHandlersInstalled){if(document.addEventListener){document.addEventListener("DOMContentLoaded",ready,false);window.addEventListener("load",ready,false)}else{document.attachEvent("onreadystatechange",readyStateChange);window.attachEvent("onload",ready)}readyEventHandlersInstalled=true}};return baseObj[funcName]}("docReady",window)},function(module,exports,__webpack_require__){var browserConfig=__webpack_require__(0),API={on:function(ele,event,callback,mode){mode=mode?true:false;if(ele.attachEvent){ele.attachEvent("on"+event,callback)}else if(ele.addEventListener){ele.addEventListener(event,callback,mode)}},contains:function(parent,child){if(parent===child){return true}var node=child.parentNode;while(node!=null){if(node==parent){return true}node=node.parentNode}return false},objToUrl:function(obj){if(typeof obj!=="object"){return false}var data="";for(var i in obj){if(obj.hasOwnProperty(i)){if(data){data+="&"}if(obj[i]instanceof Array){for(var j=0;j<obj[i].length;j++){data+=i+(j+1)+"="+obj[i][j]}}else{data+=i+"="+obj[i]}}}return data},sendData:function(url,data){if(typeof url!=="string"||typeof data!=="object"){return false}var toFeedback=url+"?"+API.objToUrl(data);try{switch(browserConfig.dataSendingMethod){case"sendBeacon":navigator.sendBeacon(toFeedback);break;case"ping":var evt=document.createEvent("MouseEvent");evt.initMouseEvent("click",true,true,window,0,0,0,0,0,false,false,false,false,0,null);browserConfig.pingEl.setAttribute("ping",toFeedback);browserConfig.pingEl.dispatchEvent(evt);break;default:(new Image()).src=toFeedback}}catch(e){if(console&&console.log){console.log("Error: "+e)}(new Image()).src=toFeedback}return true}};module.exports=API},function(module,exports,__webpack_require__){var browserConfig=__webpack_require__(0),utils=__webpack_require__(2),docReady=__webpack_require__(1),listeners=__webpack_require__(4),w=window,checkTimeout=3e3,d=document;function TrackingNode($el,callback){if(!callback||typeof callback!=="function"){throw new Error("Tracking node need a callback")}this.el=$el;this.callbackCalled=false;var me=this;this.callback=function(){me.callbackCalled=true;callback.apply(null,arguments)};this.blurTS=null}function GncTracker(){var nodesToTrack=[],lastNodeActive=null,event=null,eventlastReqAnimTime=null,eventBlurTs=null,lastPageHiddenTs=null,getActiveNode=function(el){for(var i=0;i<nodesToTrack.length;i++){if(utils.contains(nodesToTrack[i].el,el)){return nodesToTrack[i]}}return false},checkIfClicked=function(ev,el){var activeNode=null;if(!el&&(d.activeElement&&typeof d.activeElement!=="undefined"&&d.activeElement.nodeName=="IFRAME")){el=d.activeElement}if(el){activeNode=getActiveNode(el)}isTrackingNodeClicked(ev,activeNode)},setupListener=function(){if(!browserConfig.trackerSupported)return false;listeners.startListerners(checkIfClicked)},isTrackingNodeClicked=function(event,activeNode){switch(event){case"blur":case"mouseover":eventBlurTs=+new Date;if(!activeNode||activeNode&&activeNode.callbackCalled)return false;if(lastPageHiddenTs&&+new Date-lastPageHiddenTs<=checkTimeout){activeNode.callback(activeNode)}else{activeNode.blurTs=eventBlurTs;lastNodeActive=activeNode}break;case"visibility":if(lastNodeActive&&!lastNodeActive.callbackCalled&&Math.abs(+new Date-lastNodeActive.blurTs)<=checkTimeout){lastNodeActive.callback(lastNodeActive)}else{lastPageHiddenTs=+new Date}break;case"onBU":if(lastNodeActive&&!lastNodeActive.callbackCalled&&(Math.abs(+new Date-lastNodeActive.blurTs)<=checkTimeout||browserConfig.name=="safari"&&Math.abs(eventlastReqAnimTime-lastNodeActive.blurTs)<=1e3)){lastNodeActive.callback(lastNodeActive)}else if(browserConfig.name=="firefox"&&Math.abs(+new Date-eventBlurTs)<=checkTimeout){if(!activeNode||activeNode&&activeNode.callbackCalled)return false;else activeNode.callback(activeNode)}break}},add=function(el,callback){if(!el||!el.nodeType||el.nodeType!==1){throw new Error("Element needs to be a valid HTML Element")}var nodeEl=new TrackingNode(el,callback);nodesToTrack.push(nodeEl);listeners.nodeListener(el,function(ev,el){if(ev==="blur"||ev==="mouseover"){checkIfClicked(ev,el)}})};setupListener();return{add:add,browserConfig:browserConfig,sendData:utils.sendData}}if(typeof(window.GncTracker)==="undefined"||typeof(window.GncTracker)!="object"||(!window.GncTracker))window.GncTracker=GncTracker();module.exports=function(){return GncTracker()}},function(module,exports,__webpack_require__){var browserConfig=__webpack_require__(0),docReady=__webpack_require__(1),utils=__webpack_require__(2),w=window,d=document,globalListeners={forBlur:function(callBack){utils.on(w,"blur",function(){if(browserConfig.name=="firefox"){setTimeout(function(){callBack("blur")},700)}else if(browserConfig.name=="safari"&&typeof w.requestAnimationFrame=="function"){(function(){var reqAnim=null;function logReqAnim(){eventlastReqAnimTime=+new Date;reqAnim=w.requestAnimationFrame(logReqAnim)}eventlastReqAnimTime=+new Date;reqAnim=w.requestAnimationFrame(logReqAnim);setTimeout(function(){w.cancelAnimationFrame(reqAnim)},1500)})();callBack("blur")}else{callBack("blur")}},true)},forAnimation:function(callBack){if(!browserConfig.animation.supported){return false}var styleAnimation,animationName="clickTracker",keyframeprefix=browserConfig.animation.keyframeprefix,pfx=browserConfig.animation.pfx,animationstring=browserConfig.animation.animationstring,eventHandler=function(event){if(event.animationName===animationName||event[animationstring]===animationName){callBack("blur",event.target)}};styleAnimation=d.createElement("style");styleAnimation.innerHTML="@"+keyframeprefix+"keyframes "+animationName+" {  from {  opacity: 0.99;  } to {  opacity: 1; }  }"+"\n iframe:active { animation-duration: 0.001s; animation-name: "+animationName+"; "+keyframeprefix+"animation-duration: 0.001s; "+keyframeprefix+"animation-name: "+animationName+"; } "+"\n iframe:hover { animation-duration: 0.001s; animation-name: "+animationName+"; "+keyframeprefix+"animation-duration: 0.001s; "+keyframeprefix+"animation-name: "+animationName+";"+" } ";d.getElementsByTagName("head")[0].appendChild(styleAnimation);d.addEventListener("animationstart",eventHandler,false);d.addEventListener("MSAnimationStart",eventHandler,false);d.addEventListener("webkitAnimationStart",eventHandler,false)}},nodeListener=function(el,callback){utils.on(el,"mouseout",function(ev){callback("mouseout",ev.target)});utils.on(el,"mouseover",function(ev){var e=ev||window.event;var t=e.target||e.srcElement;callback("mouseover",t)});utils.on(el,"click",function(ev){var e=ev||window.event;var t=e.target||e.srcElement;callback("blur",t)},true)};startListerners=function(callBack){globalListeners.forBlur(callBack);globalListeners.forAnimation(callBack);utils.on(window,browserConfig.unloadMethod,function(){callBack("onBU")});browserConfig.pageVisibility.onChange(function(){callBack("visibility")},function(){})};module.exports={nodeListener:nodeListener,startListerners:startListerners}}]);(function(){function gn(ss,ln,pk){var sb,sn,sq,pl,pi,il;if(!ss)return null;ss=decodeURIComponent(ss);sb=ss.indexOf("?");if(sb<0)return null;sn=ss.indexOf(ln);if(sn<0||sn+ln.length>=sb)return null;sq=ss.substring(sb+1);pl=sq.split("&");for(pi=0;pi<pl.length;pi++){il=pl[pi].split("=");if(il.length>=2&&il[0]==pk&&il[1].length>0)return il[1];}return null;}function rt(){var sl,si,go,cc;sl=document.getElementsByTagName("script");for(si=sl.length-1;si>=0;si--){go=gn(sl[si].src,"rtct_adp_lib","SotodaDeliveryZoneName");if(go){cc=go+".registerClickTracking();";eval(cc);}}}rt();})();
